Ketinit();

Setketcindyjs(["Sc=1.5","No=all","Fig=y","Ax=n","Co=offwhite"]);//no ketjs
Setwindow([-7,7],[-6,6]);
Slider("T",[-5,-4],[5,-4]);
Addax(0);

Inf=10000;

str1="[a,b]=[4,3]";// no ketjs on
str0="A.xy=";
str3="norbit=5";
str4="bisect=";// no ketjs off

//str0=Textedit(65);// only ketjs on
//str3=Textedit(68);
//str4=Textedit(69);
//str1=Textedit(66);// only ketjs off

tmp=Getcindystr(str1);
if(length(tmp)>0,
  tmp=parse(tmp);
  a=tmp_1; b=tmp_2;
);

tmp=Getcindystr(str0);
if(length(tmp)>0,
  if(substring(tmp,0,1)=="[",
    A.xy=parse(tmp);
  ,
    tmp=parse(tmp);
    A.xy=[a*cos(tmp),b*sin(tmp)];
  );
);
pF=[-sqrt(a^2-b^2),0];
C.xy=pF;

tmp=Getcindystr(str3);
norb=parse(tmp);

tmp=Getcindystr(str4);
tmp=Strsplit(tmp,":");
if(length(tmp_1)>0,
  v1=parse(tmp_1);
  if(!islist(v1),v1=[-1,v1]);
,
  v1=[Inf,0];
);
if(length(tmp)>1,
  if(length(tmp_2)>0,
    v2=parse(tmp_2);
    if(!islist(v2),v2=[-1,v2]);
  );
,
  v2=[Inf,0];
);
if(length(tmp)>2,
  if(length(tmp_3)>0,xy=parse(tmp_3),xy=Inf);
  if((v1_1!=Inf)&(v2_1!=Inf)&(xy!=Inf),
    findorbit=1;
  );
);
Drwxy();
fun=Assign("[a*cos(t),b*sin(t)]",["a",a,"b",b]);
Paramplot("1",fun,"t=[0,2*pi]");
Pointdata("1",C,["Size=3","Color=red","border->false"]);
Letter(T+[0,-0.1],"s",2^(Ptpos(T)_1+5),["Size=1.2","notex"]);

orbit(v):=(
  regional(pL);
  tpv=[0,A.xy,v/|v|];
  pL=[tpv];
  forall(1..norb,
   tpv=fans(a,b,tpv);
   pL=append(pL,tpv);
  );
  pL;
);
bisect(v1org,v2org,xy):=(
  regional(eps,v1,v2,tmp1,tmp2,y0,v,ym,pL);
  eps=10^(-10);
  y0=A.xy_xy;
  v1=v1org; v2=v2org;
  pL=orbit(v1); tmp1=pL_(-1)_2_xy;
  pL=orbit(v2); tmp2=pL_(-1)_2_xy;
  if(tmp1>y0,
    v=v1; v1=v2; v2=v;
  );
  repeat(50,
    v=(v1+v2)/2;
    pL=orbit(v);
    ym=pL_(-1)_2_xy;
    if(abs(ym-y0)>eps,
      if(ym<y0,
        v1=v;
      ,
        v2=v;
      );
    );
  );
  [v/|v|,pL];
);

if(v1_1<Inf,
  tmp=orbit(v1);
  tmp1=apply(tmp,#_2);
  Listplot("o1",tmp1,["do"]);
  Pointdata("o1",[tmp1_(-1)],["Size=2"]);
);
if(v2_1<Inf,
  tmp=orbit(v2);
  tmp2=apply(tmp,#_2);
  Listplot("o2",tmp2,["do","Color=blue"]);
  Pointdata("o2",[tmp2_(-1)],["Size=2","Color=blue"]);
  if(v1_1<Inf,
    tmp=orbit((v1+v2)/2);
    tmp3=apply(tmp,#_2);
    Pointdata("o3",[tmp3_(-1)],["Size=2","Color=green"]);
  );
);

if(findorbit==1,
  Changestyle(["sgo1","sgo2","pto1L","pto2L","pto3L"],["nodisp"]);
  Eps=10^(-10);
  tmp=bisect(v1,v2,xy);
  v=tmp_1;
  pL=tmp_2;
  if(orbitflg==1,
    tmp1=apply(tmp_2,#_2);
    Listplot("o3",tmp1,["Color=red"]);
    Letter([-7,-0.5],"e",Textformat(A.xy,6));
    Letter([-7,-1.5],"e",Textformat(v,6));
    Letter([-7,-2.5],"e",Textformat(pL_(-1)_2,6));
    Letter([-7,-3.5],"e",Textformat(pL_(-1)_3,6));
  );
);

tmax=500;
if(trajflg==1,
 if(initflg==1,
   tpv=[0,A.xy,v/|v|];
   pL=[tpv];
   while(tpv_1<tmax,
     tpv=fans(a,b,tpv);
     pL=append(pL,tpv);
   );
   initflg=0;
 );
 mf(ss):=(
   regional(plist,nn,tp1,tp2,pt);
   plist=select(pL,#_1<=ss);
   plist=apply(plist,[#_1,#_2]);
   nn=length(plist);
   tp1=plist_nn;
   if(tp1_1<ss,
     tp2=pL_(nn+1)_[1,2];
     pt=tp1_2+(tp2_2-tp1_2)/(tp2_1-tp1_1)*(ss-tp1_1);
     plist=append(plist,[ss,pt]);
   );
   if(length(plist)>1,
     Listplot("1",apply(plist,#_2));
   );
 );

 ss=Animationparam(0,2^(T.x+5),[0,tmax]);
 mf(ss);
 Letter([-4.5,1.5],"nw",text(re(floor(ss))),["Size=1.2"]);
);//1

Windispg();
